// SerialIn
void DoSerialIn() {
  int incomingByte = 0;
  double p,i,d;
  double p_d =0.02;
  double i_d = 0.02;
  double d_d = 0.02;
  // Serial input
  if (Serial.available() > 0) {
    p=ejector_P;
    i=ejector_I;
    d=ejector_D;
    switch (Serial.read()) {
    case 'p':
      PrintEjectorUpdate(p,i,d,p+p_d,i,d);
      p=p+p_d;
      ejector_P=p;
      break;
    case 'P':
      PrintEjectorUpdate(p,i,d,p-p_d,i,d);
      p=p-p_d;
      ejector_P=p;
      break;
    case 'i':
      PrintEjectorUpdate(p,i,d,p,i+i_d,d);
      i=i+i_d;
      ejector_I=i;
      break;
    case 'I':
      PrintEjectorUpdate(p,i,d,p,i-i_d,d);
      i=i-i_d;
      ejector_I=i;
      break;
    case 'd':
      PrintEjectorUpdate(p,i,d,p,i,d+d_d);
      d=d+d_d;
      ejector_D=d;
      break;
    case 'D':
      PrintEjectorUpdate(p,i,d,p,i,d-d_d);
      d=d-d_d;
      ejector_D=d;
      break;
    case 'c':
      CalibratePressureSensors();
      LoadPressureSensorCalibration();
      break;
    case 's':
      servo1_pos += 10;
      Serial.print("#Servo1 (degrees) now:");
      Serial.println(servo1_pos);
      break;
    case 'S':
      servo1_pos -= 10;
      Serial.print("#Servo1 (degrees) now:");
      Serial.println(servo1_pos);
      break;
    case 'e':
      ejector_setpoint += 1000;
      Serial.print("#Ejector Setpoint now:");
      Serial.println(ejector_setpoint);
      break;
    case 'E':
      ejector_setpoint -= 1000;
      Serial.print("#Ejector Setpoint now:");
      Serial.println(ejector_setpoint);
      break;
    case 't':
      loopPeriod1 = min(loopPeriod1+100,loopPeriod2);
      Serial.print("#Sample Period now:");
      Serial.println(loopPeriod1);
      break;
    case 'T':
      loopPeriod1 = min(loopPeriod1-100,loopPeriod2);
      Serial.print("#Sample Period now:");
      Serial.println(loopPeriod1);
      break;
    case 'g':  
      analogWrite(GRATE_SOLENOID, 255);
      delay(gratePulseLength);
      analogWrite(GRATE_SOLENOID, 0);
      Serial.println("#Grate Shaken");
      grateOn = true;
      break;
    case 'G':  
      switch (grateMode) {
      case GRATE_OFF:
        grateMode = GRATE_ON;
        Serial.println("#Grate Mode: On");
        break;
      case GRATE_ON:
        grateMode = GRATE_PRATIO;
        Serial.println("#Grate Mode: Pressure Ratio");
        break;
      case GRATE_PRATIO:
        grateMode = GRATE_OFF;
        Serial.println("#Grate Mode: Off");
        break;
      }
      break;  
    case 'm':
      gratePeriod += 500;
      Serial.print("#Grate Interval now:");
      Serial.println(gratePeriod);
      break;
    case 'M':
      gratePeriod -= 500;
      Serial.print("#Grate Interval now:");
      Serial.println(gratePeriod);
      break;   
    }
  }
}

void PrintEjectorUpdate(double P, double I, double D, double nP, double nI, double nD) {
  Serial.print("#Updating ejector PID from [");
  Serial.print(P);
  Serial.print(",");
  Serial.print(I);
  Serial.print(",");
  Serial.print(D);
  Serial.print("] to [");
  Serial.print(nP);
  Serial.print(",");
  Serial.print(nI);
  Serial.print(",");
  Serial.print(nD);
  Serial.println("]");
}

